package jp.starlogic.jms.axis;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.StringTokenizer;

import org.seasar.framework.container.S2Container;
import org.seasar.framework.container.factory.S2ContainerFactory;
public class Customer {
	private static final String PATH = "jp/starlogic/jms/axis/client.dicon";

	private OrderCounter counter;

	public Customer() {
		S2Container container = S2ContainerFactory.create(PATH);
		container.init();

		counter = (OrderCounter) container.getComponent(OrderCounter.class);
	}

	public int order(OrderInfo info) {
		return counter.order(info);
	}

	public boolean isOrderComplete(int orderNo) {
		return counter.isOrderComplete(orderNo);
	}
	
	public String execute(String cmdline) {
		StringTokenizer tokenizer = new StringTokenizer(cmdline, ",");
		String cmd = tokenizer.nextToken().trim();
		if (cmd.equals("odr")) {
			String kind = tokenizer.nextToken().trim();
			String item = tokenizer.nextToken().trim();
			String tmp = tokenizer.nextToken().trim();
			int qty = Integer.valueOf(tmp).intValue();

			OrderInfo info = new OrderInfo();
			info.setKind(kind);
			info.setItem(item);
			info.setQuantity(qty);

			return String.valueOf(order(info));
		} else if (cmd.equals("qry")) {
			String tmp = tokenizer.nextToken().trim();
			int orderNo = Integer.valueOf(tmp).intValue();
			return String.valueOf(isOrderComplete(orderNo));
		}

		return "";
	}

	public static void main(String[] args) throws Exception {
		Customer cust = new Customer();

		BufferedReader stdin = new BufferedReader(new InputStreamReader(
				System.in));
		System.out.println("Enter: R}h(odrAqry), (A), i, ");
		System.out.println("\ne.g. odr, sakana, sanma, 10 ");

		while (true) {
			String cmdline = stdin.readLine();
			if (cmdline != null && cmdline.length() > 0) {
				String res = cust.execute(cmdline);
				System.out.println(res);
			} else {
				System.exit(0);
			}
		}

	}
}
