package jp.starlogic.jms.axis;

import java.util.HashMap;
import java.util.Map;

import javax.jms.JMSException;
import javax.naming.NamingException;

import jp.starlogic.jms.saler.Agent;

public class OrderCounterImpl implements OrderCounter {
	private Agent agent;
	
	private static Map orderList = new HashMap();
	private static int orderNo;
	
	boolean inited = false;
	
	public OrderCounterImpl() {
		super();
	}

	public void setAgent(Agent agent) {
		this.agent = agent;
	}

	private static int getOrderNo() {
		return ++orderNo;
	}
	
	private void init() {
		if (!inited) {
			try {
				agent.init(this, "counter", "counter", 1800000);
				inited = true;
			} catch (NamingException e) {
				e.printStackTrace();
			} catch (JMSException e) {
				e.printStackTrace();
			}
		}
	}
	
	public void orderComplete(OrderInfo info) {
		orderList.put(new Integer(info.getOrderNo()), info);
	}

	public int order(OrderInfo info) {
		init();
 		int orderNo = getOrderNo();
		orderList.put(new Integer(orderNo), null);
		info.setOrderNo(orderNo);
		agent.order(info);

		return orderNo;
	}

	public boolean isOrderComplete(int orderNo) {
		return orderList.get(new Integer(orderNo)) != null;
	}

}
