package jp.starlogic.jms.jndi;

import javax.jms.QueueConnectionFactory;
import javax.jms.TopicConnectionFactory;
import javax.naming.NamingException;

public class JmsConnectionFactoryImpl implements JmsConnectionFactory {
	private JmsContext jmsContext;
	private String topicConnectionFactoryName;
	private String queueConnectionFactoryName;

	public void setContext(JmsContext jmsContext) {
		this.jmsContext = jmsContext;
	}

	public void setQueueConnectionFactoryName(String queueConnectionFactoryName) {
		this.queueConnectionFactoryName = queueConnectionFactoryName;
	}

	public void setTopicConnectionFactoryName(String topicConnectionFactoryName) {
		this.topicConnectionFactoryName = topicConnectionFactoryName;
	}

	public TopicConnectionFactory getTopicConnectionFactory()
			throws NamingException {
		return (TopicConnectionFactory) jmsContext.getContext()
				.lookup(topicConnectionFactoryName);
	}

	public QueueConnectionFactory getQueueConnectionFactory()
			throws NamingException {
		return (QueueConnectionFactory) jmsContext.getContext()
				.lookup(queueConnectionFactoryName);
	}

}
